import gnu.gdk.*;
import gnu.glade.LibGlade;
import gnu.gtk.*;

public class gui
{
  configreader config;
  getwidgets gw;
  GtkWindow aboutwin;
  GtkFileSelection dlldirselection;
  GtkFileSelection fontdirselection;
  GtkFileSelection openfile;
  GtkFileSelection savefile;
  GtkButton chanel;
  GtkButton adddrv;
  GtkWindow drvdlgwin;
  GtkEntry name;
  GtkEntry path;
  GtkEntry device;
  GtkEntry type;
  GtkEntry filesystem;
  LibGlade drvdlg;
  LibGlade mainglade;

  public gui() //Make the main-window per constructor
  {
    mainglade= new LibGlade(this, "jine.glade", null);

    //gw = new getwidgets(mainglade, config);         Not here, only standardsettings are shown at startup!
  }

  //Some gtk-callback-funktions
  private void gtk_main_quit()
  {
    Gtk.mainQuit();
    //return true;
  }

  private void on_quit_activate()
  {
    Gtk.mainQuit();
  }

  private void on_about_activate() //Make a new window when Menu->About was clicked
  {
    LibGlade about = new LibGlade(this, "about.glade", null);
    aboutwin=(GtkWindow)about.getWidget("window1");
    aboutwin.setTransientFor(gw.window);
  }


  private void on_addirbutton_clicked()
  {
        dlldirselection = new GtkFileSelection("file selection");
	//dlldirselection.setFilename("TestGTK.java");

	GtkButton okButton = dlldirselection.getOkButton();
	okButton.signalConnect("clicked", "fileOkSel", this);

	GtkButton cancelButton = dlldirselection.getCancelButton();
	cancelButton.signalConnect("clicked", "destroy", dlldirselection);

        dlldirselection.show();

  }

  private void on_addfontdir_clicked()
  {
        fontdirselection = new GtkFileSelection("Please select font-directory...");
	GtkButton okButton = fontdirselection.getOkButton();
	okButton.signalConnect("clicked", "fontDirOk", this);

	GtkButton cancelButton = fontdirselection.getCancelButton();
	cancelButton.signalConnect("clicked", "destroy", fontdirselection);

        fontdirselection.showAll();
  }

  private void fontDirOk()
  {
    String tmpstring;

    tmpstring = fontdirselection.getFilename();

    if(!(tmpstring.equals("")))
    {
      if((tmpstring.substring((tmpstring.length()-1),(tmpstring.length()))).equals("/")) //Look if there was an file instead of an dir selected and correct the path
      {
        gw.addFontList(tmpstring);
        fontdirselection.destroy();
      }
    }
  }

  private void openf()
  {
    String tmpstring;
    GtkWindow tmpwindow;
    LibGlade tmpglade;

    tmpstring = openfile.getFilename();

    if(!(tmpstring.equals("")))
    {
      if(!(tmpstring.substring((tmpstring.length()-1),(tmpstring.length()))).equals("/")) //Look if there was an file instead of an dir selected and correct the path
      {
        //Here code can be added for what should happen if  an existing file should be opend...
        config = new configreader(tmpstring);
        tmpwindow = (GtkWindow)mainglade.getWidget("mainwindow");
        tmpglade = new LibGlade(this, "jine.glade", null);
        tmpwindow.hide(); //I know this causes memory-leaks, but when we destroy, the application terminates...
        gw = new getwidgets(tmpglade, config);

        openfile.destroy(); //At the end of all operations we must terminate the file-dialog..
      }
    }
  }

  private void savef()
  {
    String tmpstring;

    tmpstring = savefile.getFilename();

    if(!(tmpstring.equals("")))
    {
      if(!(tmpstring.substring((tmpstring.length()-1),(tmpstring.length()))).equals("/")) //Look if there was an file instead of an dir selected and correct the path
      {
        getvalues gv = new getvalues(gw, config, tmpstring);

        savefile.destroy(); //At the end of all operations we must terminate the file-dialog..
      }
    }
  }

  private void fileOkSel()
  {
    String tmpstring;

    tmpstring = dlldirselection.getFilename();

    if(!(tmpstring.equals("")))
    {
      if(!(tmpstring.substring((tmpstring.length()-1),(tmpstring.length()))).equals("/")) //Look if there was an file instead of an dir selected and correct the path
      {
      }
      else
      {
        gw.addDllList(tmpstring);
        dlldirselection.destroy();
      }
    }
  }

  private void on_aboutexit_clicked()
  {
    aboutwin.destroy();
  }

  private void on_rmdirfontbut_clicked()
  {
    gw.rmfontrow();
  }

  private void on_rmdirbutton_clicked()
  {
    gw.rmdlllist1row();
  }

  private void on_delbutton_clicked()
  {
    gw.rmdriverow();
  }

  private void on_addbutton_clicked()
  {
    drvdlg = new LibGlade(this, "newdrive.glade", null);

    name = (GtkEntry) drvdlg.getWidget("entry6");
    path =  (GtkEntry) drvdlg.getWidget("entry1");
    device = (GtkEntry) drvdlg.getWidget("entry3");
    type = (GtkEntry) drvdlg.getWidget("combo-entry1");
    filesystem = (GtkEntry) drvdlg.getWidget("combo-entry2");
    chanel = (GtkButton) drvdlg.getWidget("button2");
    adddrv = (GtkButton) drvdlg.getWidget("button1");
    drvdlgwin = (GtkWindow) drvdlg.getWidget("drvdlgwin");
    drvdlgwin.setTransientFor(gw.window);

 }

 private  void on_adddrive_clicked()
 {
    String strname = name.getText();
    String strpath = path.getText();
    String strdevice = device.getText();
    String strtype = type.getText();
    String strfs = filesystem.getText();

    if(!((name.equals(""))||(path.equals(""))||(device.equals(""))))
    {
      gw.addlistdrive(strname, strpath, strdevice, strtype, strfs);
      drvdlgwin.destroy();
    }
 }

 private void on_tbb3_clicked()
 {
  if(config!=null)
  {
   savefile = new GtkFileSelection("Please select font-directory...");
   GtkButton okButton = savefile.getOkButton();
   okButton.signalConnect("clicked", "savef", this);

   GtkButton cancelButton = savefile.getCancelButton();
   cancelButton.signalConnect("clicked", "destroy", savefile);

   savefile.showAll();
  }
 }

 private void on_save_activate()
 {
  on_tbb3_clicked();
 }

 private void on_open_activate()
 {
  on_tbb2_clicked();
 }

 private void on_save_as_activate()
 {
  on_tbb3_clicked();
 }
 private void on_tbb2_clicked()
 {
   openfile = new GtkFileSelection("Please select font-directory...");
   GtkButton okButton = openfile.getOkButton();
   okButton.signalConnect("clicked", "openf", this);

   GtkButton cancelButton = openfile.getCancelButton();
   cancelButton.signalConnect("clicked", "destroy", openfile);

   openfile.showAll();
 }

 private  void on_chanelb_clicked()
 {
    drvdlgwin.destroy();
 }
}
