import java.util.*;
import java.lang.*;

public class configreader
{
  public LinkedList linearray = new LinkedList();
  public LinkedList drivearray = new LinkedList();
  public String windows_path = new String();
  public dllObj dll_obj = new dllObj();
  public x11Obj x11_obj = new x11Obj();
  public fontObj font_obj = new fontObj();
  public hwObj hw_obj = new hwObj();
  public afmdirsObj afmdirs_obj = new afmdirsObj();
  public registryObj registry_obj = new registryObj();
  public layoutObj layout_obj = new layoutObj();
  public clipboardObj clipboard_obj = new clipboardObj();
  public winmmObj winmm_obj = new winmmObj();
  public consoleObj console_obj = new consoleObj();
  public LinkedList afmdirsarray = new LinkedList();

  public configreader(String fopenname)
  {
    long differenz; //some varibles for benchs...
    long start = System.currentTimeMillis();

     //Make some instances
    getdata getdata = new getdata();
    thrdatas checkdata = new thrdatas();
    arraychange arc = new arraychange();
    safety safe = new safety();
    writedata wrdata = new writedata();

    //Load some stuff
    linearray=getdata.load_config(fopenname);
    drivearray = getdata.load_drives();
    dll_obj = (dllObj) getdata.load_pathdlls();
    hw_obj = (hwObj) getdata.load_hw();
    x11_obj = (x11Obj) getdata.load_x11();
    console_obj = (consoleObj) getdata.load_console(); //Console must be loaded before winmm for parameters!!
    winmm_obj = (winmmObj) getdata.load_winmm(console_obj);
    clipboard_obj = (clipboardObj) getdata.load_clipboard();
    font_obj = (fontObj) getdata.load_fonts();
    layout_obj = (layoutObj)getdata.load_layout();
    registry_obj = (registryObj) getdata.load_registry();
    afmdirsarray = (LinkedList)getdata.load_afmdirs();


    //Play a little bit around
    LinkedList array2;
    //arc.adddrv(drivearray, "T", "TestPath", "Testtype", "Testdevice", "TestFS");
    /*if(array2!=null)
    {
      drivearray=array2;
    }*/

    //drivearray=arc.rmdrv(drivearray, "T");
    //checkdata.thrpaths(dll_obj);
    checkdata.thrdriveconfig(drivearray);
    //safe.safe_config(linearray);
    //wrdata.delete_config(linearray);
    //wrdata.write_config(drivearray, dll_obj, x11_obj, font_obj,hw_obj ,registry_obj,layout_obj, console_obj, clipboard_obj, afmdirsarray, winmm_obj);


    long ende = System.currentTimeMillis();
    differenz = ende-start;
    System.out.print("\nVerbrauchte zeit fr einparsen des File:"+(differenz)+"ms\n");
  }
}