import gnu.gdk.*;
import gnu.gtk.*;
import gnu.glade.*;
import java.util.*;

public class getvalues
{
  //Definition of data-klasses
  private  getwidgets gw;
  private  configreader config;
  private  LinkedList linearray = new LinkedList();
  private  LinkedList drivearray = new LinkedList();
  private  String windows_path = new String();
  private  dllObj dll_obj = new dllObj();
  private  x11Obj x11_obj = new x11Obj(); //implementiert!
  private  fontObj font_obj = new fontObj();
  private  hwObj hw_obj = new hwObj();
  private  afmdirsObj afmdirs_obj = new afmdirsObj();
  private  registryObj registry_obj = new registryObj();
  private  layoutObj layout_obj = new layoutObj();
  private  clipboardObj clipboard_obj = new clipboardObj();
  private  winmmObj winmm_obj = new winmmObj();
  private  consoleObj console_obj = new consoleObj();
  private  LinkedList afmdirsarray = new LinkedList();
  //Definition of work-klasses
  private writedata wrdata = new writedata();
  private btos bs = new btos();
  private arraychange ls = new arraychange();

  //Defined widgets in getdata
  /*public GtkWindow window;
  public GtkScrolledWindow fontwin;
  public GtkScrolledWindow dllwin1;
  public GtkScrolledWindow dllwin2;
  public GtkScrolledWindow drivewin;
  public String[] drivecolumns = {"name","path","type","device","filesystem"};
  public GtkCList dlllist1 = new GtkCList(1);
  public GtkCList dlllist2 = new GtkCList(1);
  public GtkCList drivelist = new GtkCList(5, drivecolumns);
  public GtkEntry windir;
  public GtkEntry sysdir;
  public GtkEntry defaultfont;
  public GtkEntry fixedfont;
  public GtkEntry seriffont;
  public GtkEntry sansseriffont;
  public GtkEntry allocsyscolors;
  public GtkEntry screendepth;
  public GtkEntry display;
  public GtkEntry xvidport;
  public GtkEntry textcp;
  public GtkEntry com1;
  public GtkEntry com2;
  public GtkEntry com3;
  public GtkEntry com4;
  public GtkEntry lpt1;
  public GtkEntry lpt2;
  public GtkEntry lpt3;
  public GtkEntry read;
  public GtkEntry write;
  public GtkEntry ppd378;
  public GtkEntry ppd278;
  public GtkEntry ppd3bc;
  public GtkEntry spoolfile;
  public GtkEntry spoollpt1;
  public GtkEntry spoollpt2;
  public GtkEntry spoollpt3;
  public GtkEntry consoledrivers;
  public GtkEntry xtermprog;
  public GtkEntry terminaltype;
  public GtkEntry initrows;
  public GtkEntry initcolumns;
  public GtkEntry exclude;
  public GtkEntry winmmdrivers;
  public GtkEntry wavemapper;
  public GtkEntry midimapper;
  public GtkToggleButton tnative1;
  public GtkToggleButton tnative2;
  public GtkToggleButton tbuiltin1;
  public GtkToggleButton tbuiltin2;
  public GtkSpinButton  resolution;
  public GtkSpinButton  xdesktop;
  public GtkSpinButton  ydesktop;
  public GtkSpinButton  periodicsave;
  public GtkCheckButton privatecmp;
  public GtkCheckButton perfectgr;
  public GtkCheckButton managed;
  public GtkCheckButton dga;
  public GtkCheckButton xshm;
  public GtkCheckButton xvidmode;
  public GtkCheckButton dxgrab;
  public GtkCheckButton doubleb;
  public GtkCheckButton sync;
  public GtkCheckButton lgrf;
  public GtkCheckButton lhrf;
  public GtkCheckButton lwrf;
  public GtkCheckButton wthrf;
  public GtkCheckButton soukeys;
  public GtkCheckButton caselections;
  public GtkCheckButton pselection;
  public GtkCombo look;
  public GtkTree drivetree;
  public GtkList dlldirectorieslist;
  public GtkAdjustment fontadj;
  public GtkCList fontdirlist = new GtkCList(1);
  public listselection fontrow = new listselection();
  public listselection dlllist1row = new listselection();
  public listdriveselection driverow = new listdriveselection();*/

  private void getdll()
  {
    String tmppath;
    int i=0;
    config.dll_obj.dllpaths.clear();
    do
    {
      tmppath=gw.dlllist1.getText(i,0);
      System.out.print(tmppath);
      config.dll_obj.dllpaths.add(tmppath);
      i++;
    }
    while(i<gw.dlllist1.getRows());

    config.dll_obj.windir = gw.windir.getText();
    config.dll_obj.sysdir = gw.sysdir.getText();

  }

  private void getmisc()
  {
    GtkEntry tmpentry;
    //Load console-specific values
    console_obj.drivers = bs.chkifset(gw.consoledrivers.getText());
    console_obj.xtermprog = bs.chkifset(gw.xtermprog.getText());
    console_obj.initialrows = bs.chkifset(gw.initrows.getText());
    console_obj.initialcolumns = bs.chkifset(gw.initcolumns.getText());
    console_obj.terminaltype = bs.chkifset(gw.terminaltype.getText());
    //Load layout-specific values
    tmpentry = gw.look.getEntry();
    layout_obj.winelook = tmpentry.getText();
    //Load winmm-specific values
    winmm_obj.drivers = bs.chkifset(gw.winmmdrivers.getText());
    winmm_obj.wavemapper = bs.chkifset(gw.wavemapper.getText());
    winmm_obj.midimapper = bs.chkifset(gw.midimapper.getText());
    //Load clipboard-specific values
    clipboard_obj.clearallselections = bs.boltostring(gw.caselections.getActive());
    clipboard_obj.persistentselection = bs.boltostring(gw.pselection.getActive());

  }

  private void getregistry()
  {
    registry_obj.loadglobalrf=bs.boltostring(gw.lgrf.getActive());
    registry_obj.loadhomerf=bs.boltostring(gw.lhrf.getActive());
    registry_obj.loadwindowsrf=bs.boltostring(gw.lwrf.getActive());
    registry_obj.writehomerf=bs.boltostring(gw.wthrf.getActive());
    registry_obj.saveonlyupdated=bs.boltostring(gw.soukeys.getActive());
        System.out.print("\n\nWert von periodicave:"+registry_obj.periodicsave.valueOf(gw.periodicsave.getValueAsInt())+"\n\n");
    registry_obj.periodicsave = bs.chkifset(registry_obj.periodicsave.valueOf(gw.periodicsave.getValueAsInt()));
  }

  public getvalues(getwidgets getwidgets, configreader configr, String newfilename)
  {
    gw = getwidgets;
    config = configr;
    writedata wr = new writedata();

    getdll();
    getdrive();
    getfonts();
    gethw();
    getmisc();
    getregistry();
    getx11();

    wr.delete_config(config.linearray, newfilename);
    wr.write_config(drivearray,config.dll_obj,x11_obj, font_obj, hw_obj, registry_obj, layout_obj, console_obj, clipboard_obj , afmdirsarray, winmm_obj, newfilename);
  }

  private void gethw()
  {
    hw_obj.com1 = bs.chkifset(gw.com1.getText());
    hw_obj.com2 = bs.chkifset(gw.com2.getText());
    hw_obj.com3 = bs.chkifset(gw.com3.getText());
    hw_obj.com4 = bs.chkifset(gw.com4.getText());
    hw_obj.lpt1 = bs.chkifset(gw.lpt1.getText());
    hw_obj.lpt2 = bs.chkifset(gw.lpt2.getText());
    hw_obj.lpt3 = bs.chkifset(gw.lpt3.getText());
    hw_obj.spfile = bs.chkifset(gw.spoolfile.getText());
    hw_obj.splpt1 = bs.chkifset(gw.spoollpt1.getText());
    hw_obj.splpt2 = bs.chkifset(gw.spoollpt2.getText());
    hw_obj.splpt3 = bs.chkifset(gw.spoollpt3.getText());
    hw_obj.ppd378 = bs.chkifset(gw.ppd378.getText());
    hw_obj.ppd278 = bs.chkifset(gw.ppd278.getText());
    hw_obj.ppd3bc = bs.chkifset(gw.ppd3bc.getText());
    hw_obj.portread = bs.chkifset(gw.read.getText());
    hw_obj.portwrite = bs.chkifset(gw.write.getText());
    hw_obj.spy = bs.chkifset(gw.exclude.getText());

  }

  public  void readwidgets()
  {
  }

  private void getdrive()
  {
    String name;
    String path;
    String type;
    String device;
    String fs;
    int i=0;

    do
    {
      name=gw.drivelist.getText(i,0);
      path=gw.drivelist.getText(i,1);
      type=gw.drivelist.getText(i,2);
      device=gw.drivelist.getText(i,3);
      fs=gw.drivelist.getText(i,4);
      drivearray=ls.adddrv(drivearray, name, path, type, device, fs);
      i++;
    }
    while(i<gw.drivelist.getRows());
  }

  private void getfonts()
  {
    int i=0;
    do
    {
      afmdirsObj tmpafm = new afmdirsObj();
      tmpafm.afmdir=gw.fontdirlist.getText(i,0);
      tmpafm.afmdirnumber=(i+1);
      afmdirsarray.add(tmpafm);
      i++;
    }
    while(i<gw.fontdirlist.getRows());

    font_obj.resolution = font_obj.resolution.valueOf(gw.resolution.getValueAsInt());
    font_obj.defaultfont = gw.defaultfont.getText();
    font_obj.fixed = gw.fixedfont.getText();
    font_obj.serif = gw.seriffont.getText();
    font_obj.sansserif = gw.sansseriffont.getText();

  }

  private void getx11()
  {
    x11_obj.xdesktop=bs.chkifset(x11_obj.xdesktop.valueOf(gw.xdesktop.getValueAsInt()));
    x11_obj.ydesktop=bs.chkifset(x11_obj.ydesktop.valueOf(gw.ydesktop.getValueAsInt()));
    x11_obj.alloccolors=bs.chkifset(gw.allocsyscolors.getText());
    x11_obj.screendepth=bs.chkifset(gw.allocsyscolors.getText());
    x11_obj.screendepth=bs.chkifset(gw.screendepth.getText());
    x11_obj.display=bs.chkifset(gw.display.getText());
    x11_obj.xvideoport=bs.chkifset(gw.xvidport.getText());
    x11_obj.textcp=bs.chkifsetcp(gw.textcp.getText());      //Here dont control if 0, because 0 is a poosible (special funktion created!) CP
    x11_obj.privatecolormap=bs.boltostring(gw.privatecmp.getActive());
    x11_obj.perfectgraphics=bs.boltostring(gw.perfectgr.getActive());
    x11_obj.managed=bs.boltostring(gw.managed.getActive());
    x11_obj.dga=bs.boltostring(gw.dga.getActive());
    x11_obj.xshm=bs.boltostring(gw.xshm.getActive());
    x11_obj.xvidmode=bs.boltostring(gw.xvidmode.getActive());
    x11_obj.dxgrab=bs.boltostring(gw.dxgrab.getActive());
    x11_obj.doublebuffer=bs.boltostring(gw.doubleb.getActive());
    x11_obj.synchronous=bs.boltostring(gw.sync.getActive());
  }
}