//This file loads widgets from the xml-glade file and sets the appropriate values
//From the config-file


import gnu.gdk.*;
import gnu.gtk.*;
import gnu.glade.*;

public class getwidgets
{
  public GtkWindow window;
  public GtkScrolledWindow fontwin;
  public GtkScrolledWindow dllwin1;
  public GtkScrolledWindow dllwin2;
  public GtkScrolledWindow drivewin;
  public String[] drivecolumns = {"name","path","type","device","filesystem"};
  public GtkCList dlllist1 = new GtkCList(1);
  public GtkCList dlllist2 = new GtkCList(1);
  public GtkCList drivelist = new GtkCList(5, drivecolumns);
  public GtkEntry windir;
  public GtkEntry sysdir;
  public GtkEntry defaultfont;
  public GtkEntry fixedfont;
  public GtkEntry seriffont;
  public GtkEntry sansseriffont;
  public GtkEntry allocsyscolors;
  public GtkEntry screendepth;
  public GtkEntry display;
  public GtkEntry xvidport;
  public GtkEntry textcp;
  public GtkEntry com1;
  public GtkEntry com2;
  public GtkEntry com3;
  public GtkEntry com4;
  public GtkEntry lpt1;
  public GtkEntry lpt2;
  public GtkEntry lpt3;
  public GtkEntry read;
  public GtkEntry write;
  public GtkEntry ppd378;
  public GtkEntry ppd278;
  public GtkEntry ppd3bc;
  public GtkEntry spoolfile;
  public GtkEntry spoollpt1;
  public GtkEntry spoollpt2;
  public GtkEntry spoollpt3;
  public GtkEntry consoledrivers;
  public GtkEntry xtermprog;
  public GtkEntry terminaltype;
  public GtkEntry initrows;
  public GtkEntry initcolumns;
  public GtkEntry exclude;
  public GtkEntry winmmdrivers;
  public GtkEntry wavemapper;
  public GtkEntry midimapper;
  public GtkToggleButton tnative1;
  public GtkToggleButton tnative2;
  public GtkToggleButton tbuiltin1;
  public GtkToggleButton tbuiltin2;
  public GtkSpinButton  resolution;
  public GtkSpinButton  xdesktop;
  public GtkSpinButton  ydesktop;
  public GtkSpinButton  periodicsave;
  public GtkCheckButton privatecmp;
  public GtkCheckButton perfectgr;
  public GtkCheckButton managed;
  public GtkCheckButton dga;
  public GtkCheckButton xshm;
  public GtkCheckButton xvidmode;
  public GtkCheckButton dxgrab;
  public GtkCheckButton doubleb;
  public GtkCheckButton sync;
  public GtkCheckButton lgrf;
  public GtkCheckButton lhrf;
  public GtkCheckButton lwrf;
  public GtkCheckButton wthrf;
  public GtkCheckButton soukeys;
  public GtkCheckButton caselections;
  public GtkCheckButton pselection;
  public GtkCombo look;
  public GtkTree drivetree;
  public GtkList dlldirectorieslist;
  public GtkAdjustment fontadj;
  public GtkCList fontdirlist = new GtkCList(1);
  public listselection fontrow = new listselection();
  public listselection dlllist1row = new listselection();
  public listdriveselection driverow = new listdriveselection();

  public getwidgets(LibGlade glade, configreader config)
  {
     drivetree =(GtkTree) glade.getWidget("tree1");
     window =(GtkWindow) glade.getWidget("mainwindow");
     windir =(GtkEntry) glade.getWidget("entry41");
     sysdir =(GtkEntry) glade.getWidget("entry42");
     defaultfont =(GtkEntry) glade.getWidget("entry4");
     fixedfont =(GtkEntry) glade.getWidget("entry5");
     seriffont =(GtkEntry) glade.getWidget("entry8");
     sansseriffont =(GtkEntry) glade.getWidget("entry7");
     allocsyscolors =(GtkEntry) glade.getWidget("entry9");
     screendepth =(GtkEntry) glade.getWidget("entry10");
     display =(GtkEntry) glade.getWidget("entry11");
     xvidport =(GtkEntry) glade.getWidget("entry12");
     textcp =(GtkEntry) glade.getWidget("entry13");
     com1 =(GtkEntry) glade.getWidget("entry24");
     com2=(GtkEntry) glade.getWidget("entry25");
     com3 =(GtkEntry) glade.getWidget("entry26");
     com4 =(GtkEntry) glade.getWidget("entry27");
     lpt1 =(GtkEntry) glade.getWidget("entry38");
     lpt2 =(GtkEntry) glade.getWidget("entry39");
     lpt3 =(GtkEntry) glade.getWidget("entry40");
     read =(GtkEntry) glade.getWidget("entry29");
     write =(GtkEntry) glade.getWidget("entry30");
     ppd378 =(GtkEntry) glade.getWidget("entry31");
     ppd278 =(GtkEntry) glade.getWidget("entry32");
     ppd3bc =(GtkEntry) glade.getWidget("entry33");
     spoolfile =(GtkEntry) glade.getWidget("entry34");
     spoollpt1 =(GtkEntry) glade.getWidget("entry35");
     spoollpt2 =(GtkEntry) glade.getWidget("entry36");
     spoollpt3 =(GtkEntry) glade.getWidget("entry37");
     consoledrivers =(GtkEntry) glade.getWidget("entry14");
     xtermprog =(GtkEntry) glade.getWidget("entry15");
     terminaltype =(GtkEntry) glade.getWidget("entry16");
     initrows =(GtkEntry) glade.getWidget("entry17");
     initcolumns =(GtkEntry) glade.getWidget("entry18");
     exclude =(GtkEntry) glade.getWidget("entry23");
     winmmdrivers =(GtkEntry) glade.getWidget("entry20");
     wavemapper =(GtkEntry) glade.getWidget("entry21");
     midimapper =(GtkEntry) glade.getWidget("entry22");
     tnative1 = (GtkToggleButton)glade.getWidget("radiobutton1");
     tnative2 = (GtkToggleButton)glade.getWidget("radiobutton3");
     tbuiltin1 = (GtkToggleButton)glade.getWidget("radiobutton2");
     tbuiltin2 = (GtkToggleButton)glade.getWidget("radiobutton4");
     resolution = (GtkSpinButton)glade.getWidget("spinbutton1");
     xdesktop = (GtkSpinButton)glade.getWidget("spinbutton2");
     ydesktop = (GtkSpinButton)glade.getWidget("spinbutton3");
     periodicsave = (GtkSpinButton)glade.getWidget("spinbutton4");
     privatecmp = (GtkCheckButton)glade.getWidget("checkbutton1");
     perfectgr = (GtkCheckButton)glade.getWidget("checkbutton2");
     managed = (GtkCheckButton)glade.getWidget("checkbutton3");
     dga = (GtkCheckButton)glade.getWidget("checkbutton4");
     xshm = (GtkCheckButton)glade.getWidget("checkbutton5");
     xvidmode = (GtkCheckButton)glade.getWidget("checkbutton6");
     dxgrab = (GtkCheckButton)glade.getWidget("checkbutton7");
     doubleb = (GtkCheckButton)glade.getWidget("checkbutton8");
     sync  = (GtkCheckButton)glade.getWidget("checkbutton9");
     lgrf = (GtkCheckButton)glade.getWidget("checkbutton10");
     lhrf = (GtkCheckButton)glade.getWidget("checkbutton11");
     lwrf = (GtkCheckButton)glade.getWidget("checkbutton12");
     wthrf = (GtkCheckButton)glade.getWidget("checkbutton13");
     soukeys =(GtkCheckButton)glade.getWidget("checkbutton14");
     caselections =(GtkCheckButton)glade.getWidget("checkbutton15");
     pselection =(GtkCheckButton)glade.getWidget("checkbutton16");
     look = (GtkCombo)glade.getWidget("combo1");
     fontwin = (GtkScrolledWindow)glade.getWidget("scrolledwindow1");
     dllwin1 = (GtkScrolledWindow)glade.getWidget("scrolledwindow2");
     dllwin2 = (GtkScrolledWindow)glade.getWidget("scrolledwindow3");
     drivewin= (GtkScrolledWindow)glade.getWidget("scrolledwindow4");


     setvalues(config);
  }

  private void setvalues(configreader config)
  {
    btos tobol = new btos(); //In this class there are all string-operations defined..
    checkstrings cs = new checkstrings();
    liststuff ls = new liststuff();

    windir.appendText(cs.checkset(config.dll_obj.windir));
    sysdir.appendText(cs.checkset(config.dll_obj.sysdir));
    defaultfont.appendText(cs.checkset(config.font_obj.defaultfont));
    fixedfont.appendText(cs.checkset(config.font_obj.fixed));
    seriffont.appendText(cs.checkset(config.font_obj.serif));
    sansseriffont.appendText(cs.checkset(config.font_obj.sansserif));
    allocsyscolors.appendText(cs.checkset(config.x11_obj.alloccolors));
    screendepth.appendText(cs.checkset(config.x11_obj.screendepth));
    display.appendText(cs.checkset(config.x11_obj.display));
    xvidport.appendText(cs.checkset(config.x11_obj.xvideoport));
    textcp.appendText(cs.checkset(config.x11_obj.textcp));
    com1.appendText(cs.checkset(config.hw_obj.com1));
    com2.appendText(cs.checkset(config.hw_obj.com2));
    com3.appendText(cs.checkset(config.hw_obj.com3));
    com4.appendText(cs.checkset(config.hw_obj.com4));
    lpt1.appendText(cs.checkset(config.hw_obj.lpt1));
    lpt2.appendText(cs.checkset(config.hw_obj.lpt2));
    lpt3.appendText(cs.checkset(config.hw_obj.lpt3));
    read.appendText(cs.checkset(config.hw_obj.portread));
    write.appendText(cs.checkset(config.hw_obj.portwrite));
    ppd378.appendText(cs.checkset(config.hw_obj.ppd378));
    ppd278.appendText(cs.checkset(config.hw_obj.ppd278));
    ppd3bc.appendText(cs.checkset(config.hw_obj.ppd3bc));
    spoolfile.appendText(cs.checkset(config.hw_obj.spfile));
    spoollpt1.appendText(cs.checkset(config.hw_obj.splpt1));
    spoollpt2.appendText(cs.checkset(config.hw_obj.splpt2));
    spoollpt3.appendText(cs.checkset(config.hw_obj.splpt3));
    consoledrivers.appendText(cs.checkset(config.console_obj.drivers));
    xtermprog.appendText(cs.checkset(config.console_obj.xtermprog));
    terminaltype.appendText(cs.checkset(config.console_obj.terminaltype));
    initrows.appendText(cs.checkset(config.console_obj.initialrows));
    initcolumns.appendText(cs.checkset(config.console_obj.initialcolumns));
    exclude.appendText(cs.checkset(config.hw_obj.spy));
    winmmdrivers.appendText(cs.checkset(config.winmm_obj.drivers));
    wavemapper.appendText(cs.checkset(config.winmm_obj.wavemapper));
    midimapper.appendText(cs.checkset(config.winmm_obj.midimapper));
    //Set the checkbuttons on or off...
    perfectgr.setActive(tobol.stringtobol(config.x11_obj.perfectgraphics));
    privatecmp.setActive(tobol.stringtobol(config.x11_obj.privatecolormap));
    managed.setActive(tobol.stringtobol(config.x11_obj.managed));
    dga.setActive(tobol.stringtobol(config.x11_obj.dga));
    xshm.setActive(tobol.stringtobol(config.x11_obj.xshm));
    xvidmode.setActive(tobol.stringtobol(config.x11_obj.xvidmode));
    dxgrab.setActive(tobol.stringtobol(config.x11_obj.dxgrab));
    doubleb.setActive(tobol.stringtobol(config.x11_obj.doublebuffer));
    sync.setActive(tobol.stringtobol(config.x11_obj.synchronous));
    lgrf.setActive(tobol.stringtobol(config.registry_obj.loadglobalrf));
    lhrf.setActive(tobol.stringtobol(config.registry_obj.loadhomerf));
    lwrf.setActive(tobol.stringtobol(config.registry_obj.loadwindowsrf));
    wthrf.setActive(tobol.stringtobol(config.registry_obj.writehomerf));
    soukeys.setActive(tobol.stringtobol(config.registry_obj.saveonlyupdated));
    caselections.setActive(tobol.stringtobol(config.clipboard_obj.clearallselections));
    pselection.setActive(tobol.stringtobol(config.clipboard_obj.persistentselection));
    //Set the falues of the spin-buttons
    resolution.setValue(Double.parseDouble(config.font_obj.resolution));
    xdesktop.setValue(tobol.stod(config.x11_obj.xdesktop));
    ydesktop.setValue(tobol.stod(config.x11_obj.ydesktop));

    periodicsave.setValue(tobol.stod(config.registry_obj.periodicsave));

    fontdirlist = ls.create_afmlist(config.afmdirsarray, fontdirlist);
    fontwin.add(fontdirlist);
    fontwin.showAll();
    dlllist1 = ls.create_dlldirlist(config.dll_obj.dllpaths, dlllist1);
    dllwin1.add(dlllist1);
    dllwin1.showAll();

    drivelist = ls.create_drivelist(config.drivearray, drivelist);
    drivewin.add(drivelist);
    drivewin.showAll();

    fontdirlist.signalConnect("select_row", "fontrowselected", this);
    dlllist1.signalConnect("select_row", "dll1rowselected", this);
    drivelist.signalConnect("select_row", "driverowselected", this);

    //This is only temporary!
    GtkLabel tmplabel = new GtkLabel("Not yet aviable!");
    dllwin2.add(tmplabel);
    dllwin2.showAll();

    //drivelist.setColumnAutoResize(1, true);
    drivelist.setColumnAutoResize(2, true);
    //drivelist.setColumnAutoResize(3, true);
    drivelist.setColumnAutoResize(4, true);
    //drivelist.setColumnAutoResize(5, true);


  }

  public void addDllList(String string)
  {
    String[] tmparray = new String[1];
    tmparray[0]=string;
    dlllist1.append(tmparray);
  }

  public void addFontList(String string)
  {
    String[] tmparray = new String[1];
    tmparray[0]=string;
    fontdirlist.append(tmparray);
  }

  public  void addlistdrive(String name, String path, String device, String type, String fs)
  {
    String[] tmpstringarray = new String[5];

    tmpstringarray[0] = name;
    tmpstringarray[1] = path;
    tmpstringarray[2] = type;
    tmpstringarray[3] = device;
    tmpstringarray[4] = fs;

    if(tmpstringarray[3].equals(""))  //Its not sure that device-entrie is set..
    {
      tmpstringarray[3]="not-set";
    }

    drivelist.insert(driverow.row, tmpstringarray);
  }

  private void fontrowselected(int row, int column, GdkEvent event)
  {
    if(column == -1)
    {
      return;
    }
    fontrow.text=fontdirlist.getText(row, column);
    fontrow.row=row;
    fontrow.column=column;
  }

  private void dll1rowselected(int row, int column, GdkEvent event)
  {
    if(column == -1)
    {
      return;
    }
    dlllist1row.text=dlllist1.getText(row, column);
    dlllist1row.row=row;
    dlllist1row.column=column;
  }

  private void driverowselected(int row, int column, GdkEvent event)
  {
    if(column == -1)
    {
      return;
    }
    driverow.text[0] = drivelist.getText(row,0);
    driverow.text[1] = drivelist.getText(row,1);
    driverow.text[2] = drivelist.getText(row,2);
    driverow.text[3] = drivelist.getText(row,3);
    driverow.text[4] = drivelist.getText(row,4);
    driverow.row=row;
    //System.out.print(driverow.text[0]+driverow.text[1]+driverow.text[2]+driverow.text[3]+driverow.text[4]);
  }

  public void rmfontrow()
  {
    fontdirlist.remove(fontrow.row);
  }

  public void rmdlllist1row()
  {
    dlllist1.remove(dlllist1row.row);
  }

  public void rmdriverow()
  {
    drivelist.remove(driverow.row);
  }

  class listdriveselection
  {
    int row;
    int column;
    String[] text = new String[5];
  }

  class listselection
  {
    int row;
    int column;
    String text;
  }
}

